##############################################################################
#    Copyright (C) 2002  MM Manager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

import Interface

class ISlideshowEncoder(Interface.Base):
    """
    General interface for MyMediaManager plugins.

    These methods need to be implemented by any class that wants to register
    as a plugin.
    """

    def getView(self):
        """
        Returns the view
        """
        
    def pushPicUrl(self, url):
        """
        Push a picture url to the encoder.
        """
        
    def listPictureUrls(self):
        """
        Return a list of absolute URL's to the pictures in the slideshow.
        """
        
    def setPictureFolder(self, folder):
        """
        Set which folder contains the pictures.
        """
        
    def getPictureFolder(self):
        """
        Returns the folder containing the pictures.
        """
        
